// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "role_side_forward.h"

#include "strategy.h"

#include "bhv_basic_offensive_kick.h"
#include "bhv_basic_move.h"

#include <rcsc/formation/formation.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/player/intercept_table.h>
#include <rcsc/player/debug_client.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>

#include <rcsc/action/neck_scan_field.h>
//#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/neck_turn_to_low_conf_teammate.h>

#include <rcsc/action/body_kick_multi_step.h>
//#include <rcsc/action/body_kick_one_step.h>

#include <rcsc/action/body_shoot.h>

// ACO 2008.05.01 

#define RANDOMIZE()  srand((unsigned int)time(NULL))
#define RANDOM(x)    (rand()%(x)) /* 0〜(x-1)を生成するマクロ */

static float ita0_box[10][6]=
  {{0.0,0.0,0.0,0.0,0.0,0.0},/*a*/
   {0.0,0.0,0.0,0.0,0.0,0.0},/*b*/
   {0.004*(1.0+1.0),0.004*(1.0+2.0),0.004*(1.0+3.0),0.004*(1.0+3.0),0.004*(1.0+2.0),0.004*(1.0+1.0)},/*c*/
   {0.001*(1.0+1.0),0.001*(1.0+2.0),0.022*(1.0+3.0),0.004*(1.0+3.0),0.001*(1.0+2.0),0.001*(1.0+1.0)},/*d*/
   {0.000*(1.0+1.0),0.000*(1.0+2.0),0.066*(1.0+3.0),0.051*(1.0+3.0),0.000*(1.0+2.0),0.000*(1.0+1.0)},/*e*/
   {0.000*(2.0+1.0),0.000*(2.0+2.0),0.065*(2.0+3.0),0.085*(2.0+3.0),0.012*(2.0+2.0),0.000*(2.0+1.0)},/*f*/
   {0.000*(3.0+1.0),0.000*(3.0+2.0),0.092*(3.0+3.0),0.097*(3.0+3.0),0.000*(3.0+2.0),0.000*(3.0+1.0)},/*g*/
   {0.000*(4.0+1.0),0.000*(4.0+2.0),0.082*(4.0+3.0),0.040*(4.0+3.0),0.000*(4.0+2.0),0.000*(4.0+1.0)},/*h*/
   {0.015*(5.0+1.0),0.015*(5.0+2.0),0.015*(5.0+3.0),0.017*(5.0+3.0),0.020*(5.0+2.0),0.015*(5.0+1.0)},/*i*/
   {0.043*(6.0+1.0),0.043*(6.0+2.0),0.043*(6.0+3.0),0.043*(6.0+3.0),0.043*(6.0+2.0),0.043*(6.0+1.0)} /*j*/
  }; /*ηの値 */

static float ph1_box[10][6]=
  {
    {1.0,1.0,1.0,1.0,1.0,1.0},/*a*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*b*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*c*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*d*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*e*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*f*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*g*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*h*/
    {1.0,1.0,1.0,1.0,1.0,1.0},/*i*/
    {1.0,1.0,1.0,1.0,1.0,1.0}/*j*/
  }; /* フェロモン値 */

static int ph_pos_x[50],ph_pos_y[50];
static int ph_pos_pop=0;

/*-------------------------------------------------------------------*/
/*!

*/
void
RoleSideForward::execute( rcsc::PlayerAgent * agent )
{
  int loop1;
  bool kickable = agent->world().self().isKickable();

    //srand( (unsigned)time( NULL ) ); 
    RANDOMIZE();

    //フィードバック処理
    // フェロモン更新
    if( agent->world().gameMode().type() == rcsc::GameMode::KickOff_ ){
      if ( agent->world().gameMode().side() == agent->world().ourSide() )
        {
	  //printf("our kick off\n");
	  return;
        }
      else
        {
	  //printf("thier kick off\n");// 自分の得点
	  for( loop1=0;loop1<ph_pos_pop;loop1++){
	    ph1_box[ ph_pos_x[loop1] ][  ph_pos_y[loop1] ] += (float)( 1.0/ (float)ph_pos_pop);
	  }
	  //for( loop1=0;loop1<ph_pos_pop;loop1++){
	  //  printf("phero get goal  %f\t", ph1_box[ ph_pos_x[loop1] ][  ph_pos_y[loop1] ]);
	  //}
          ph_pos_pop=0;
 	  return;
        }
    }

    if( agent->world().gameMode().type() == rcsc::GameMode::CornerKick_ ){
      if ( agent->world().gameMode().side() == agent->world().ourSide() )
        {
	  //printf("our corner kick\n");//自分のコーナーキック
	  for( loop1=0;loop1<ph_pos_pop;loop1++){
	    ph1_box[ ph_pos_x[loop1] ][  ph_pos_y[loop1] ] += (float)( 0.5/ (float)ph_pos_pop);
	  }
	  //for( loop1=0;loop1<ph_pos_pop;loop1++){
	  //  printf("phero coner %f\t", ph1_box[ ph_pos_x[loop1] ][  ph_pos_y[loop1] ]);
	  //}
          ph_pos_pop=0;
	  return;
        }
      else
        {
	  //printf("thier corner kick\n");
	  return;
        }
 
    }
    if( agent->world().gameMode().type() == rcsc::GameMode::GoalKick_ ){
      if ( agent->world().gameMode().side() == agent->world().ourSide() )
        {
	  //printf("our goal kick\n");
	  return;
        }
      else
        {
	  //printf("thier goal kick\n");//相手チームのゴールキック
	  for( loop1=0;loop1<ph_pos_pop;loop1++){
	    ph1_box[ ph_pos_x[loop1] ][  ph_pos_y[loop1] ] += (float)( 0.1/ (float)ph_pos_pop);
	  }
	  //for( loop1=0;loop1<ph_pos_pop;loop1++){
	  //  printf("phero their goalkick %f\t", ph1_box[ ph_pos_x[loop1] ][  ph_pos_y[loop1] ]);
	  //}
          ph_pos_pop=0;
	  return;
        }
 
    }


    if ( agent->world().existKickableTeammate()
         && agent->world().teammatesFromBall().front()->distFromBall()
         < agent->world().ball().distFromSelf() )
    {
        kickable = false;
    }

    if ( kickable )
    {
      /* ボールの位置にフェロモン加算 */

      /* 配列の処理　大きさ３０のケース*/
      /* 29:古い 0:新しい */
      int loop1;
      for(loop1=ph_pos_pop;loop1>0;loop1--){
        ph_pos_x[loop1]=ph_pos_x[loop1-1];
        ph_pos_y[loop1]=ph_pos_y[loop1-1];
      }
      if( ph_pos_pop < 30) ph_pos_pop++;
      /* 区画の特定 */
      float tmp_x=agent->world().ball().pos().x;
      float tmp_y=agent->world().ball().pos().y;
      /* X */
      if(  tmp_x <= -40.0 ){
        ph_pos_x[0]=0;
      }else if( tmp_x <= -30.0 ){
        ph_pos_x[0]=1;
      }else if( tmp_x <= -20.0 ){
        ph_pos_x[0]=2;
      }else if( tmp_x <= -10.0 ){
        ph_pos_x[0]=3;
      }else if( tmp_x <= 0.0 ){
        ph_pos_x[0]=4;
      }else if( tmp_x <= 10.0 ){
        ph_pos_x[0]=5;
      }else if( tmp_x <= 20.0 ){
        ph_pos_x[0]=6;
      }else if( tmp_x <= 30.0 ){
        ph_pos_x[0]=7;
      }else if( tmp_x <= 40.0 ){
        ph_pos_x[0]=8;
      }else if( tmp_x <= 60.0 ){
        ph_pos_x[0]=9;
      }
      /* Y */
      if( tmp_y <= -20.0 ){
        ph_pos_y[0]=0;
      }else if( tmp_y <= -10.0 ){
        ph_pos_y[0]=1;
      }else if( tmp_y <= 0.0 ){
        ph_pos_y[0]=2;
      }else if( tmp_y <= 10.0 ){
        ph_pos_y[0]=3;
      }else if( tmp_y <= 20.0 ){
        ph_pos_y[0]=4;
      }else{
        ph_pos_y[0]=5;
      }

      int p0 =  RANDOM(1000);  // p0:500 以下デフォルトの処理、それ以外ACO
      if( p0 > 500 && tmp_x > -15.0 ){
	//printf("ACO point\n");
	doKick2( agent );
      }else{
        doKick( agent );
      }
    }
    else
    {
        doMove( agent );
    }

}

/*-------------------------------------------------------------------*/
/*!

*/
void
RoleSideForward::doKick( rcsc::PlayerAgent * agent )
{
    switch ( Strategy::get_ball_area( agent->world().ball().pos() ) ) {
    case Strategy::BA_ShootChance:
      //      rcsc::Body_Shoot().execute( agent );
      //break;
    case Strategy::BA_CrossBlock:
    case Strategy::BA_Stopper:
    case Strategy::BA_Danger:
    case Strategy::BA_DribbleBlock:
    case Strategy::BA_DefMidField:
    case Strategy::BA_DribbleAttack:
    case Strategy::BA_OffMidField:
    case Strategy::BA_Cross:
    default:
        Bhv_BasicOffensiveKick().execute( agent );
        break;
    }
}

/*-------------------------------------------------------------------*/
/*!

*/
void
RoleSideForward::doKick2( rcsc::PlayerAgent * agent )
{
  // 蹴り出す位置決定
  // フェロモン値の算出
  int loop1, loop2, max_p=0, tmp_p=0;
  float loop01, loop02;
  float tmp_x=0.0, tmp_y=0.0;
  for( loop1=0;loop1<10;loop1++){
    for( loop2=0;loop2<6;loop2++){
      max_p += (int)(1000.0*( ita0_box[loop1][loop2]*ph1_box[loop1][loop2] ));
    }
  }

  RANDOMIZE();
  int p1 = RANDOM(max_p);

  /* ポジの決定 */
  tmp_p = 0;loop01=0.0;loop02=0.0;
  for( loop1=0;loop1<10;loop1++){
    for( loop2=0;loop2<6;loop2++){
      tmp_p += (int)(1000.0*( ita0_box[loop1][loop2]*ph1_box[loop1][loop2] ));
      if( tmp_p > p1 ){
	loop01=(float)loop1;loop02=(float)loop2;
	break;
      }
    }
    if( tmp_p > p1 ) break;
  }

  //printf("ACO max_p %d p1 %d tmp_p %d\n",max_p, p1,tmp_p);        
  /* 位置座標の計算 */
  /* x座標 */
  //tmp_x = -45.0+loop01*10.0; 
  if( loop01 <  4 ){
    tmp_x = 0.0;
  }else if( loop01 == 4){
    tmp_x = 5.0;
  }else if( loop01 == 5){
    tmp_x = 15.0;
  }else if( loop01 == 6){
    tmp_x = 25.0;
  }else if( loop01 == 7 ){
    tmp_x = 35.0;
  }else if( loop01 == 8 ){
    tmp_x = 45.0;
  }else {
    tmp_x = 55.0;
  }

  /* y座標 */
  //tmp_y = -30.0+loop02*10.0;
  if( loop02 ==0 ){
    tmp_y = -25.0;
  }else if( loop02 == 1 ){
    tmp_y = -15.0;
  }else if( loop02 == 2 ){
    tmp_y = -5.0;
  }else if( loop02 == 3 ){
    tmp_y = 5.0;
  }else if( loop02 == 4 ){
    tmp_y = 15.0;
  }else {
    tmp_y = 25.0;
  }

 
  // 座標(tmp_x, tmp_y)に蹴り出す
  bool safety = true;
  const rcsc::WorldModel & wm = agent->world();
  const rcsc::PlayerPtrCont & opps = wm.opponentsFromSelf();
  const rcsc::PlayerPtrCont::const_iterator opps_end = opps.end();
  const rcsc::Vector2D pas_pt(tmp_x, tmp_y);

  for ( rcsc::PlayerPtrCont::const_iterator it = opps.begin();
	it != opps_end;
	++it )
    {
      if ( (*it)->pos().dist( rcsc::Vector2D( tmp_x, tmp_y ) ) < 2.0 )
	{
	  safety = false;
	}
    }
  double min_ply1 = 100.0;
  double min_ply2 = 100.0;
  const rcsc::PlayerObject * ply1 = wm.getTeammateNearestTo(pas_pt, 10, &min_ply1);
  const rcsc::PlayerObject * ply2 = wm.getOpponentNearestTo(pas_pt, 10, &min_ply2);

  if ( safety && ply1 && min_ply1 < min_ply2 )
    {
      //* 到達可能な速度で蹴り出す


      double dist1 = ply1->rcsc::PlayerObject::distFromSelf();
      double  dist2 = wm.self().pos().dist(pas_pt);
      int t1 = wm.interceptTable()->teammateReachCycle();
  
      double sp =  (dist2+dist1)/(double)t1 ;




      //if( tmp_x < -15 )
      //	sp += (double)(RANDOM(5));
      //else
      //	sp += (double)(RANDOM(2));
      // multi step kick
      rcsc::Body_KickMultiStep(  rcsc::Vector2D( tmp_x, tmp_y ),
				 sp, true ).execute( agent );
      //printf("ACO multistepkick side (x,y)=(%f %f)(sp :: %f)\n",tmp_x,tmp_y,sp);
      printf("ACO multistepkick side (x,y)=(%f %f)(sp :: %f l %f t1 %d)\n", tmp_x,tmp_y,sp, dist2+dist1, t1);
      //rcsc::Body_KickOneStep(  rcsc::Vector2D( tmp_x, tmp_y ), sp ).execute( agent );
      //printf("ACO onestepkick (x,y)=(%f %f)(sp %f)\n",tmp_x,tmp_y,sp);
            //      agent->setNeckAction( new rcsc::Neck_TurnToBallOrScan() );
    }

  agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );

}

/*-------------------------------------------------------------------*/
/*!

*/
void
RoleSideForward::doMove( rcsc::PlayerAgent * agent )
{
    const rcsc::WorldModel & wm = agent->world();

    int ball_reach_step = 0;
    if ( ! wm.existKickableTeammate()
         && ! wm.existKickableOpponent() )
    {
        ball_reach_step
            = std::min( wm.interceptTable()->teammateReachCycle(),
                        wm.interceptTable()->opponentReachCycle() );
    }
    const rcsc::Vector2D base_pos
        = wm.ball().inertiaPoint( ball_reach_step );

    rcsc::Vector2D home_pos
        = formation().getPosition( agent->config().playerNumber(),
                                   base_pos );
    if ( rcsc::ServerParam::i().useOffside() )
    {
        home_pos.x = std::min( home_pos.x, wm.offsideLineX() - 1.0 );
    }

    rcsc::dlog.addText( rcsc::Logger::ROLE,
                        "%s: HOME POSITION=(%.2f, %.2f) base_point(%.1f %.1f)"
                        ,__FILE__,
                        home_pos.x, home_pos.y,
                        base_pos.x, base_pos.y );

    switch ( Strategy::get_ball_area( base_pos ) ) {
    case Strategy::BA_CrossBlock:
    case Strategy::BA_Stopper:
    case Strategy::BA_Danger:
    case Strategy::BA_DribbleBlock:
    case Strategy::BA_DefMidField:
    case Strategy::BA_DribbleAttack:
    case Strategy::BA_OffMidField:
    case Strategy::BA_Cross:
    case Strategy::BA_ShootChance:
    default:
        Bhv_BasicMove( home_pos ).execute( agent );
        break;
    }
}
